import matplotlib
import matplotlib.pyplot as plot
import numpy as np
import mysql.connector
import array
import sys
import time
from sys import exit

#################################################################

# Controllo numero argomenti a linea di comando
if (len(sys.argv) != 6):
	print ("Syntax:")
	print ("dataDisplay <servAddr> <minChan> <maxChan> <#Chann> <logY (Y/N)>")
	exit (1)
	
# Estrazione dalla linea di comando dei parametri di lavoro
hostAddress = sys.argv[1]
minChannel  = int(sys.argv[2])
maxChannel  = int(sys.argv[3])
numChannels = int(sys.argv[4])
logY        = sys.argv[5].upper()
					
# Definizione della finestra
fig = plot.figure("GRASS - Channels", figsize=(13.5, 6.5))

# Compone la query per estrarre il timeStamp piu recente
sqlScw = "SELECT DISTINCT acqTimeStamp FROM grassdb.events ORDER BY acqTimeStamp ASC LIMIT 1"

num_bins = numChannels    # numero di bin per l'istogramma
loopStatus = "Running"
acqTimeStamp = ""

# Definisce i vettori riga e colonna del rivelatore
channelDataX = np.empty((8), dtype=object)
channelDataY = np.empty((8), dtype=object)

while (loopStatus != "Exit"):

#	print("Interrogo")
	conn = mysql.connector.connect(
								user='grass', \
								password='hemera2022', \
								host=hostAddress, \
								database='grassdb' \
								)

	# Crea un cursore per il database grassdb
	cursor = conn.cursor()
	status = cursor.execute("START TRANSACTION READ ONLY")
	
	# Esegue la query
	status = cursor.execute("SELECT DISTINCT acqTimeStamp FROM grassdb.events ORDER BY acqTimeStamp ASC LIMIT 1")
	print ("Interrogo")
	
	# Legge l'ultimo valore di acqTimeStamp
	acqTimeStampTuple = cursor.fetchone()
	cursor.close()
	conn.close()

	# Se esiste almeno un set di dati lo processa
	if (acqTimeStampTuple):
		print ("Ricevo")

		print (acqTimeStamp, str(acqTimeStampTuple [0]))
		# Se il set di dati e' nuovo lo processa
		if (acqTimeStamp != str(acqTimeStampTuple [0])):
			print("Elaboro")

			acqTimeStamp = str(acqTimeStampTuple [0])

			conn = mysql.connector.connect(
										user='grass', \
										password='hemera2022', \
										host=hostAddress, \
										database='grassdb' \
										)

			# Crea un cursore per il database grassdb
			cursor = conn.cursor()
			
			# Preleva l'intero set di dati
			query = "SELECT * FROM events WHERE acqTimeStamp = " \
					+ \
					"'" \
					+ \
					acqTimeStamp +"'"
			
			cursor.execute(query)
			selectOutput = cursor.fetchall()
			
	
			# Valore receivedFrames
			query = "SELECT count(DISTINCT acqTimeStamp) FROM events"
	
			# Esegue la query
			cursor.execute(query)
	
			# Accede al risultato della query
			receivedFrames = cursor.fetchone()
			cursor.close()
			conn.close()

			channelDataX.fill([])
			channelDataY.fill([])
			
			for row in selectOutput:
				# acqTimeStamp   = row [0]
				eventTimeStamp = row [1]
				eventCounter   = row [2]

				for channel in range(0,8):
					channelDataX [channel] = np.append (channelDataX [channel], row [channel + 3])
	
				for channel in range(0,8):
					channelDataY [channel] = np.append (channelDataY [channel], row [channel + 11])
			
			plot.clf()
			plot.subplots_adjust(left=None, bottom=None, right=None, top=None, wspace=None, hspace=0.5)

			ax = fig.add_subplot(4,4,(1))
			if logY == "Y":
				plot.yscale('log')
			n, bins, columns = ax.hist(channelDataX [0], num_bins, range=[minChannel, maxChannel])
			ax.set_title('Chan:' + str(1) + ' (row. 1)', size=10)

			for channel in range(1,8):
				ax = fig.add_subplot(4,4,(channel + 1))
				if logY == "Y":
					plot.yscale('log')
				n, bins, columns = ax.hist(channelDataX [channel], num_bins, range=[minChannel, maxChannel])
				ax.set_title('Chan:' + str(channel + 1) + ' (row. ' + str(channel + 1) + ')', size=10)
	
			for channel in range(0,8):
				ax = fig.add_subplot(4,4,(channel + 9))
				if logY == "Y":
					plot.yscale('log')
				n, bins, columns = ax.hist(channelDataY [channel], num_bins, range=[minChannel, maxChannel])
				ax.set_title('Chan:' + str(channel + 9) + ' (col. ' + str(channel + 1) + ')', size=10)
#			plot.tight_layout()
             
			# DATA FRAME TIME
			dataFrameTime = \
							acqTimeStamp[8:10] + \
							"/" + \
							acqTimeStamp[5:7] + \
							"/" + \
							acqTimeStamp[0:4] + \
							" " + \
							acqTimeStamp[11:13] + \
							":" + \
							acqTimeStamp[14:16] + \
							":" + \
							acqTimeStamp[17:19]
			plot.suptitle(dataFrameTime+" Received frames: "+str(receivedFrames[0]), fontsize=14, fontweight='bold')
			plot.draw()
#			plot.pause(15.0)
		
#		else:
#			print("Aspetto")

	plot.pause(5.0)

#	time.sleep(5)
			
# Chiude la connessione con il server mysql
plot.close()
